#include "job.h"
#include <assert.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
//TOUS EST CHANGee
int get_job_oDegree(job_t * J) {
    assert(J);
    return J->output_degree;
}

void set_job_oDegree(job_t * J, int oDegree) {
    assert(J);
    J->output_degree = oDegree;
}

void incr_job_oDegree(job_t * J) {
    assert(J);
    J->output_degree++;
}

void decr_job_oDegree(job_t * J) {
    assert(J);
    J->output_degree--;
}

int get_job_rank(job_t * J) {
    assert(J);
    return J->rank;
}

void set_rank(job_t * J, int rank) {
    assert(J);
    J->rank = rank;
}

int titleJobCmp(job_t * J1, job_t * J2) {
    assert(J1 && J2);
    return strcmp(J1->title, J2->title);
}

int iDegreeJobCmp(job_t * J1, job_t * J2) {
    assert(J1 && J2);
    return J1->input_degree - J2->input_degree;
}

int oDegreeJobCmp(job_t * J1, job_t * J2) {
    assert(J1 && J2);
    return J1->output_degree - J2->output_degree;
}

int rangJobCmp(job_t * J1, job_t * J2) {
    assert(J1 && J2);
    return J1->rank - J2->rank;
}
