#include "list_1 (1).h"
#include "list"
#include <stdlib.h>
#include <stdbool.h>
#include <stdio.h>
#include <assert.h>

typedef struct{
    elmlist_t * head;
    elmlist_t * tail;
    int numelm;
  } list_t ;
  // Create an empty list
  list_t * new_list(){
  list_t * t = calloc(1, sizeof(list_t));
    assert(t);
    return t;
  }
  // Delete list, its elements and possibly the data
  //DOIT CONFIRMER LE STRUCT
  void del_list(list_t ** ptrL, void (*ptrf) ()){
  assert(ptrL && *ptrL);
  list_t * L = *ptrL;
    if(ptrf){
      for(elmlist_t * E = L->head; E; ){
          elmlist_t * T = E;
          E = E->suc;
          (*ptrf)(T->data);
          free(T);
      }
  }
  } else {
  	for(elmlist_t * E = L->head; E ; ){
  		elmlist_t * T = E;
  		E = E->suc;
  		free(T);
  	}
  free(*ptrL);
  (*ptrL) = NULL;
}
  // Clean list; delete its elments but keep data and the list
  void clean(list_t * L){
    assert(L);
    elmlist_t *curr = L->head;
    while (curr != NULL) {
        elmlist_t *temp = curr;
        curr = curr->suc;
        free(temp);
    }
    L->head = NULL;
    L->tail = NULL;
    L->numelm = 0;
}
  // Is list L empty ?
  bool is_empty(list_t * L){
  assert(L);
  if (L->numelm == 0) return true;
    return false;
  }

  elmlist_t * get_head(list_t * L){
    assert(L);
    L = L->head;
    return L;
  }

  elmlist_t * get_tail(list_t * L){
    assert(L);
    L = L->tail;
    return L;
  }
  
  
  